﻿var DateTime={
	SetLanguage:function(language){
		if (language==-1){
			language=navigator.userLanguage.substr(0,2);
		}
		this.AbbMonths=[];
		this.AbbDays=[];
		switch (language){
			case "af":
				// Afrikaans
				this.Days=["Sondag","Maandag","Dinsdag","Woensdag","Donderdag","Vrydag","Saterdag"];
				this.Months=["Januarie","Februarie","Maart","April","Mei","Junie","Julie","Augustus","September","Oktober","November","Desember"];
				break;
			case "ar":
				// Arabic
				this.Days=["يوم الإثنين","يوم الثلاثاء","يوم الأربعاء","يوم الخميس","يوم الجمعة","يوم السبت","يوم الأحد"];
				this.AbbDays=["إثن","ثلا","أرب","خمي","جمع","سبت","أحد"];
				this.Months=["يناير","فبراير","مارس","أبريل","مايو","يونيو","يوليه","أغسطس","سبتمبر","أكتوبر","نوفمبر","ديسمبر"];
				break;
			case "az":
				// Azerbaijani
				this.Days=["Bazar günü","Bazar ërtësi","Çërşënbë axşamı","Çërşënbë günü","Cümë axşamı","Cümë günü","Şënbë"];
				this.AbbDays=["Bag","Baë","Çëa","Çëg","Cüa","Cüg","Şën"];
				this.Months=["Yanvar","Fevral","Mart","Aprel","May","İyun","İyul","Avqust","Sentyabr","Oktyabr","Noyabr","Dekabr"];
				break;
			case "bg":
				// Bulgarian
				this.Days=["неделя","понеделник","вторник","сряда","четвъртък","петък","събота"];
				this.Months=["януари","февруари","март","април","май","юни","юли","август","септември","октомври","ноември","декември"];
				break;
			case "br":
				// Breton
				this.Days=["disul","dilun","dimeurz","dimerher","diriaou","digwener","disadorn"];
				this.AbbDays=["sul","lun","meu","mer","ria","gwe","sad"];
				this.Months=["miz Genver","miz C'hwevrer","miz Meurzh","miz Ebrel","miz Mae","miz Mezheven","miz Gouere","miz Eost","miz Gwengolo","miz Here","miz Du","miz Kerzu"];
				this.AbbMonths=["Gen","C'h","Meu","Ebr","Mae","Mez","Gou","Eos","Gwe","Her","Du","Ker"];
				break;
			case "ca":
				// Catalan
				this.Days=["diumenge","dilluns","dimarts","dimecres","dijous","divendres","dissabte"];
				this.AbbDays=["ume","llu","mar","mec","jou","ven","ssa"];
				this.Months=["gener","febrer","març","abril","maig","juny","juliol","agost","setembre","octubre","novembre","desembre"];
				break;
			case "co":
				// Corsican
				this.Days=["dumenica","luni","marti","marcuri","ghjovi","venneri","sabbatu"];
				this.Months=["ghjennaghju","ferraghju","marzu","aprile","maghju","ghjugnu","lugliu","aostu","sittembre","uttobre","nuvembre","dicembre"];
				break;
			case "cs":
				// Czech
				this.Days=["nedĕle","pondĕlí","úterý","středa","čtvrtek","pátek","sobota"];
				this.Months=["leden","únor","březen","duben","květen","červen","červenec","srpen","září","říjen","listopad","prosinec"];
				break;
			case "cy":
				// Welsh
				this.Days=["dydd Sul","dydd Llun","dydd Mawrth","dydd Mercher","dydd Iau","dydd Gwener","dydd Sadwrn"];
				this.AbbDays=["Sul","Llu","Maw","Mer","Iau","Gwe","Sad"];
				this.Months=["ionawr","chwefror","mawrth","ebrill","mai","mehefin","gorffennaf","awst","medi","hydref","tachwedd","rhagfyr"];
				break;
			case "da":
				// Danish
				this.Days=["søndag","mandag","tirsdag","onsdag","torsdag","fredag","lørdag"];
				this.Months=["januar","februar","marts","april","maj","juni","juli","august","september","oktober","november","december"];
				break;
			case "de":
				// German
				this.Days=["Sonnstag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"];
				this.Months=["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"];
				break;
			case "el":
				// Greek
				this.Days=["Κυριακή","Δευτέρα","Τρίτη","Τετάρτη","Πέμπτη","Παρασκευή","Σάββατο"];
				this.Months=["Iανουάριος","Φεβρουάριος","Μάρτιος","Aρίλιος","Μάιος","Iούνιος","Iούλιος","Αύγουστος","Σεπτέμβριος","Oκτώβριος","Νοέμβριος","Δεκέμβριος"];
				break;
			case "es":
				// Spanish
				this.Days=["domingo","lunes","martes","miércoles","jueves","viernes","sábado"];
				this.Months=["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"];
				break;
			case "et":
				// Estonian
				this.Days=["pühapäev","esmaspäev","teisipäev","kolmapäev","neljapäev","reede","laupäev"];
				this.Months=["jaanuar","veebruar","märts","aprill","mai","juuni","juuli","august","september","oktoober","november","detsember"];
				break;
			case "eu":
				// Basque
				this.Days=["igandea","astelehena","asteartea","asteazkena","osteguna","ostirala","larunbata"];
				this.Months=["urtarril","otsail","martxo","apiril","maiatz","ekain","uztail","abuztu","irail","urri","azaro","abendu"];
				break;
			case "fi":
				// Finnish
				this.Days=["sunnuntai","maanantai","tiistai","keskiviikko","torstai","perjantai","lauantai"];
				this.Months=["tammikuu","helmikuu","maaliskuu","huhtikuu","toukokuu","kesäkuu","heinäkuu","elokuu","syyskuu","lokakuu","marraskuu","joulukuu"];
				break;
			case "fj":
				// Fijian
				this.Days=["Sigatabu","Mōniti","Tūsiti","Vukelulu","Lotulevu","Vakaraubuka","Vakarauwai"];
				this.Months=["Jaanueri","Feperueri","Maji","Epereli","Mee","Junee","Julai","Okosita","Sepiteba","Okotova","Nooveba","Tiiseba"];
				break;
			case "fo":
				// Faroese
				this.Days=["sunnudagur","mánadagur","týsdagur","mikudagur","hósdagur","fríggjadagur","leygardagur"];
				this.Months=["januar","februar","mars","apríl","mai","juni","juli","august","september","oktober","november","desember"];
				break;
			case "fr":
				// French
				this.Days=["dimanche","lundi","mardi","mercredi","jeudi","vendredi","samedi"];
				this.Months=["janvier","février","mars","avril","mai","juin","juillet","août","septembre","octobre","novembre","décembre"];
				break;
			case "ga":
				// Irish
				this.Days=["Dé Domhnaigh","Dé Luan","Dé Mairt","Dé Céadaoin","Déardaoin","Dé h-Aoine","Dé Sathairn"];
				this.AbbDays=["Dom","Lua","Mai","Céa","ard","h-A","Sat"];
				this.Months=["Eanáir","Feabhra","Márta","Aibreain","Bealtaine","Meitheamh","Íuil -","Lúnasa","Meán Fómhair","Deireadh Fómhair","Samhain","Nollaig"];
				break;
			case "gl":
				// Galician
				this.Days=["domingo","luns","martes","mércores","xoves","venres","sábado"];
				this.Months=["xaneiro","febreiro","marzo","abril","maio","xuño","xullo","agosto","setembro","outubro","novembro","decembro"];
				break;
			case "gv":
				// Manx
				this.Days=["Jedoonee","Jelhune","Jemayrt","Jecrean","Jerdein","Jeheiney","Jesarn"];
				this.AbbDays=["doo","lhu","may","cre","rde","hei","sar"];
				this.Months=["Jerrey-geuree","Toshiaght-arree","Mayrnt","Averil","Boaldyn","Mean-souree","Jerrey-souree","Luanistyn","Mean-fouyir","Jerrey-fouyir","Mee Houney","Mee ny Nollick"];
				break;
			case "he":
				// Hebrew
				this.Days=["יום ראשון","יום שני","יום שלישי","יום רביעי","יום חמישי","יום שישי","יום שבת"];
				this.AbbDays=["ראש","שני","שלי","רבי","חמי","שיש","שבת"];
				this.Months=["ינואר","פברואר","מרץ","אפריל","מאי","יוני","יולי","אוגוסט","ספטמבר","אוקטובר","נובמבר","דצמבר"];
				break;
			case "hi":
				// Hindi
				this.Days=["रविवार","सोमवार","मंगलवार","बुधवार","गुरुवार","शुक्रवार","शनिवार"];
				this.Months=["जनवरी","फ़रवरी","मार्च","अप्रैल","मे","जून","जुलै","अगस्त","सितंबर","अकटूबर","नवंबर","दिसंबर"];
				break;
			case "hr":
				// Croatian
				this.Days=["nedjelja","ponedjeljak","utorak","srijeda","četvrtak","petak","subota"];
				this.Months=["siječanj","veljača","ožujak","travanj","svibanj","lipanj","srpanj","kolovoz","rujan","listopad","studeni","prosinac"];
				break;
			case "hu":
				// Hungarian
				this.Days=["vasárnap","hétfő","kedd","szerda","csütörtök","péntek","szombat"];
				this.Months=["január","február","március","április","május","június","július","augusztus","szeptember","október","november","december"];
				break;
			case "id":
				// Indonesian
				this.Days=["Minggu","Senin","Selasa","Rabu","Kamis","Jumat","Sabtu"];
				this.Months=["Januari","Februari","Maret","April","Mei","Juni","Juli","Agustus","September","Oktober","November","Desember"];
				break;
			case "is":
				// Icelandic
				this.Days=["sunnudagur","mánudagur","þriðjudagur","miðvikudagur","fimmtudagur","föstudagur","laugardagur"];
				this.Months=["janúar","febrúar","mars","apríl","maí","júní","júlí","ágúst","september","október","nóvember","desember"];
				break;
			case "it":
				// Italian
				this.Days=["domenica","lunedì","martedì","mercoledì","giovedì","venerdì","sabato"];
				this.Months=["gennaio","febbraio","marzo","aprile","maggio","giugno","luglio","agosto","settembre","ottobre","novembre","dicembre"];
				break;
			case "ja":
				// Japanese
				this.Days=["日曜日","月曜日","火曜日","水曜日","木曜日","金曜日","土曜日"];
				this.Months=["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"];
				break;
			case "kk":
				// Kazakh
				this.Days=["жексенбi","дүйсенбi","сейсенбi","сәрсенбі","бейсенбі","жұма","сенбі"];
				this.Months=["Қаңтар","Ақпан","Наурыз","Сәуір","Мамыр","Маусым","Шілде","Тамыз","Қыркүйек","Қазан","Қараша","Желтоқсан"];
				break;
			case "ko":
				// Korean
				this.Days=["일요일","월요일","화요일","수요일","목요일","금요일","토요일"];
				this.Months=["일월","이월","삼월","사월","오월","유월","칠월","팔월","구월","시월","십일월","십이월"];
				break;
			case "kw":
				// Cornish
				this.Days=["dy' Sul","dy' Lun","dy' Meurth","dy' Mergher","dy' Yow","dy' Gwener","dy' Sadorn"];
				this.AbbDays=["Sul","Lun","Meu","Mer","Yow","Gwe","Sad"];
				this.Months=["Mys Genver","Mys Hwevrer","Mys Merth","Mys Ebrel","Mys Me","Mys Methevan","Mys Gortheren","Mys Est","Mys Gwynngala","Mys Hedra","Mys Du","Mys Kevardhu"];
				break;
			case "la":
				// Latin
				this.Days=["diēs solis","diēs lūnae","diēs martis","diēs mercurī","diēs iovis","diēs veneris","diēs saturnī"];
				this.AbbDays=["sol","lūn","mar","mer","iov","ven","sat"];
				this.Months=["Iānuārius","Februārius","Martius","Aprīlis","Māius","Iūnius","Iūlius","Augustus","September","Octōber","November","December"];
				break;
			case "lt":
				// Lithuanian
				this.Days=["Sekmadienis","Pirmadienis","Antradienis","Trečiadienis","Ketvirtadienis","Penktadienis","Šeštadienis"];
				this.Months=["sausis","vasaris","kovas","balandis","gegužė","birželis","julie","augustus","september","oktober","november","desember"];
				break;
			case "lv":
				// Latvian
				this.Days=["svētdiena","pirmdiena","otrdiena","trešdiena","ceturtdiena","piektdiena","sestdiena"];
				this.Months=["janvāris","februāris","marts","aprīlis","maijs","jūnijs","jūlijs","augusts","septembris","oktobris","novembris","decembris"];
				break;
			case "mi":
				// Maori
				this.Days=["rātapu","rāhine","rātū","rāapa","rāpare","rāmere","rāhoroi"];
				this.AbbDays=["tap","hin","tū","apa","par","mer","hor"];
				this.Months=["Kohitātea","Hui tanguru","Poutū te rangi","Paengawhāwhā","Haratua","Pipiri","Hōngoingoi","Hereturikōkā","Mahuru","Whiringa ā nuku","Whiringa ā rangi","Hakihea"];
				break;
			case "mk":
				// Macedonian
				this.Days=["Недела","Понеделник","Вторник","Среда","Четврток","Петок","Сабота"];
				this.Months=["јануари","февруари","март","април","мај","јуни","јули","август","септември","октомври","ноември","декември"];
				break;
			case "ms":
				// Malay
				this.Days=["Ahad","Isnin","Selasa","Rabu","Khamis","Jumaat","Sabtu"];
				this.Months=["Januari","Februari","Mac","April","Mei","Jun","Julai","Ogos","September","Oktober","November","Diċembru"];
				break;
			case "mt":
				// Maltese
				this.Days=["il-Ħadd","it-Tnejn","it-Tlieta","l-Erbgħa","il-Ħamis","il-Ġimgħa","is-Sibt"];
				this.AbbDays=["Ħad","Tne","Tli","Erb","Ħam","Ġim","Sib"];
				this.Months=["Jannar","Frar","Marzu","April","Mejju","Ġunju","Lulju","Awissu","Settembru","Ottubru","Novembru","is-Sibt"];
				break;
			case "nl":
				// Dutch
				this.Days=["zondag","maandag","dinsdag","woensdag","donderdag","vrijdag","zaterdag"];
				this.Months=["januari","februari","maart","april","mei","juni","juli","augustus","september","oktober","november","december"];
				break;
			case "oc":
				// Occitan
				this.Days=["dimenge","diluns","dimars","dimècres","dijóus","divendres","dissabte"];
				this.AbbDays=["men","lun","mar","mèc","jóu","ven","ssa"];
				this.Months=["genièr","febrièr","març","abril","mai","junh","julh","agóst","setembr","octobre","novembre","decembre"];
				break;
			case "pl":
				// Polish
				this.Days=["niedziela","poniedziałek","wtorek","środa","czwartek","piątek","sobota"];
				this.Months=["styczeń","luty","marzec","kwiecień","maj","czerwiec","lipiec","sierpień","wrzesień","październik","listopad","grudzień"];
				break;
			case "pt":
				// Portuguese
				this.Days=["domingo","segunda-feira","terça-feira","quarta-feira","quinta-feira","sexta-feira","sábado"];
				this.Months=["janeiro","fevereiro","março","abril","maio","junho","julho","agosto","setembro","outubro","novembro","dezembro"];
				break;
			case "ro":
				// Romanian
				this.Days=["duminică","luni","marţi","miercuri","joi","vineri","sîmbătă"];
				this.Months=["ianuarie","februarie","martie","aprilie","mai","iunie","iulie","august","septembrie","octombrie","noiembrie","decembrie"];
				break;
			case "ru":
				// Russian
				this.Days=["воскресенье","понедельник","вторник","среда","четверг","пятница","суббота"];
				this.Months=["январь","февраль","март","апрель","май","июнь","июль","август","сентябрь","октябрь","ноябрь","декабрь"];
				break;
			case "sc":
				// Sardinian
				this.Days=["dumíniga","lunis","martis","mércuris","giòvia","chenábura","sáppadu"];
				this.Months=["gennarju","friarju","martzu","abrili","mayu","làmpadas","arjolas","austu","cabudanni","ladàmini","donnyasantu","idas"];
				break;
			case "sk":
				// Slovak
				this.Days=["nedel'a","pondelok","utorok","streda","svtvrtok","piatok","sobota"];
				this.Months=["január","február","marec","apríl","máj","jún","júl","august","september","október","november","december"];
				break;
			case "sl":
				// Slovenian
				this.Days=["Nedelja","Ponedeljek","Torek","Sreda","Četrtek","Petek","Sobota"];
				this.Months=["januar","februar","marec","april","maj","junij","julij","avgust","september","oktober","november","december"];
				break;
			case "sq":
				// Albanian
				this.Days=["e diel","e hënë","e martë","e mërkurë","e enjte","e premte","e shtunë"];
				this.AbbDays=["die","hën","mar","mër","enj","pre","sht"];
				this.Months=["janar","shkurt","mars","prill","maj","qershor","korrik","gusht","shtator","tetor","nëntor","dhjetor"];
				break;
			case "sr":
				// Serbian
				this.Days=["Недеља","Понедељак","Уторак","Среда","Четвртак","Петак","Субота"];
				this.Months=["јануар","фебруар","март","април","мај","јуни","јули","август","септембар","октобар","новембар","децембар"];
				break;
			case "sv":
				// Swedish
				this.Days=["söndag","måndag","tisdag","onsdag","torsdag","fredag","lördag"];
				this.Months=["januari","februari","mars","april","maj","juni","juli","augusti","september","oktober","november","december"];
				break;
			case "sw":
				// Swahili
				this.Days=["jumapili","jumatatu","jumanne","jumatano","alhamisi","ijumaa","jumamosi"];
				this.AbbDays=["api","ata","ann","ata","alh","iju","amo"];
				this.Months=["januari","februari","machi","aprili","mei","juni","julai","agosti","septemba","oktoba","novemba","desemba"];
				break;
			case "th":
				// Thai
				this.Days=["วันอาทิตย์","วันจันทร์","วันอังคาร","วันพุธ","วันพฦหัสบดี","วันศุกร์","วันเสาร์"];
				this.AbbDays=["อาท","จัน","อัง","พุธ","พฦห","ศุก","เสา"];
				this.Months=["มกราคม","กุมภาพันธ์","มีนาคม","เมษายน","พฤษภาคม","มิถุนายน","กรกฎาคม","สิงหาคม","กันยายน","ตุลาคม","พฤศจิกายน","ธันวาคม"];
				break;
			case "tr":
				// Turkish
				this.Days=["Pazar","Pazartesi","Salı","Çarşamba","Perşembe","Cuma","Cumartesi"];
				this.Months=["ocak","şubat","mart","nisan","mayis","haziran","temmuz","ağustos","eylül","ekim","kasım","aralık"];
				break;
			case "uk":
				// Ukrainian
				this.Days=["неділя","понеділок","вівторок","середа","четвер","п'ятниця","субота"];
				this.Months=["січень","лютий","березень","квітень","травень","червень","липень","серпень","вересень","жовтень","листопад","грудень"];
				break;
			case "vi":
				// Vietnamese
				this.Days=["chủ nhật","thứ hai","thứ ba","thứ tư","thứ năm","thứ sáu","thứ bảy"];
				this.AbbDays=["nhậ","hai","ba","tư","năm","sáu","bảy"];
				this.Months=["tháng một","tháng hai","tháng ba","tháng tư","tháng năm","tháng sáu","tháng bảy","tháng tám","tháng chín","tháng mười","tháng mười một","tháng mười hai"];
				this.AbbMonths=["một","hai","ba","tư","năm","sáu","bảy","tám","chí","mườ","mmộ","mha"];
				break;
			case "wa":
				// Walloon
				this.Days=["dimenge","londi","mårdi","mierkidi","djudi","vénrdi","semdi"];
				this.Months=["djanvî","fevrî","måss","avri","may","djun","djulete","awousse","setimbe","octôbe","nôvimbe","decimbe"];
				break;
			case "yi":
				// Yiddish
				this.Days=["זונטיק","מאָנטיק","דינסטיק","מיטװאָך","דאָנערשטיק","פֿרײַטיק","שבת"];
				this.Months=["יאַנואַר","פֿעברואַר","מאַרץ","אַפּריל","מײַ","יוני","יוני","אױגוסט","סעפּטעמבער","אָקטאָבער","נאָװעמבער","דעצעמבער"];
				break;
			case "zh":
				// Chinese
				this.Days=["拜一","拜二","拜三","拜四","拜五","拜六","禮拜日"];
				this.AbbDays=["一","二","三","四","五","六","日"];
				this.Months=["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"];
				break;
			case "zu":
				// Zulu
				this.Days=["iSonto","uMombuluko","uLwesibili","uLwesithathu","uLwesine","uLewishlanu","uMgqibelo"];
				this.Months=["uJanuwari","uFebruwari","uMashi","uApreli","uMeyi","uJuni","uJulayi","uAgasti","uSebutemba","uOkthoba","uNovemba","uDisemba"];
				this.AbbDays=["Son","Mom","Lwe","Lwe","Lwe","Lew","Mgq"];
				this.AbbMonths=["Jan","Feb","Mas","Apr","Mey","Jun","Jul","Aga","Seb","Okt","Nov","Dis"];
				break;
			default:
				this.Months=["January","February","March","April","May","June","July","August","September","October","November","December"];
				this.Days=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
				break;				
		}
		if (this.AbbMonths.length==0){
			for (i=0;i<12;i++){
				this.AbbMonths[i]=this.Months[i].substr(0,3);
			}
		}
		if (this.AbbDays.length==0){
			for (i=0;i<7;i++){
				this.AbbDays[i]=this.Days[i].substr(0,3);
			}
		}
	},
	SpokenFormat:function(strDate,spokenType24,byDateObj,byDate,byTimeZone){
		if (byDateObj==""){
			byDateObj=this.GetDateObj(byDate,byTimeZone);
		}
		var ret=strDate;
		var strSpeak24="";
		switch (spokenType24){
			case "military":
				if (byDateObj.H=="00"){
					strSpeak24="zero hundred";
				}else if(byDateObj.H.substr(0,1)=="0"){
					strSpeak24="o "+byDateObj.H.substr(1,1)+" hundred";
				}else{
					strSpeak24=byDateObj.H+" hundred";
				}
				if (byDateObj.i!="00"){
					if(byDateObj.i.substr(0,1)=="0"){
						strSpeak24+=" and "+byDateObj.i.substr(1,1);
					}else{
						strSpeak24+=" and "+byDateObj.i;
					}
				}
				strSpeak24+=" hours";
				break;
			case "hours":
				strSpeak24=byDateObj.G;
				if (byDateObj.i=="00"){
					strSpeak24+=" hours";
				}else if(byDateObj.i.substr(0,1)=="0"){
					strSpeak24+=" o "+byDateObj.i.substr(1,1);
				}else{
					strSpeak24+=" "+byDateObj.i;
				}
				break;
			case "oclock":
				strSpeak24=byDateObj.G;
				if (byDateObj.i=="00"){
					strSpeak24+=" o'clock";
				}else if(byDateObj.i.substr(0,1)=="0"){
					strSpeak24+=" o "+byDateObj.i.substr(1,1);
				}else{
					strSpeak24+=" "+byDateObj.i;
				}
				break;
		}
		strSpeak24=" "+strSpeak24+" ";
		ret=ret.replace(/%G:%i/g,strSpeak24);
		ret=ret.replace(/%H:%i/g,strSpeak24);
		return ret;
	},
	Format:function(strDate,byDateObj,byDate,byTimeZone){
		if (byDateObj==""){
			byDateObj=this.GetDateObj(byDate,byTimeZone);
		}
		var ret=strDate;
		//DAY
		ret=ret.replace(/%d/g,byDateObj.d);
		ret=ret.replace(/%j/g,byDateObj.j);
		ret=ret.replace(/%D/g,byDateObj.D);
		ret=ret.replace(/%l/g,byDateObj.l);
		ret=ret.replace(/%S/g,byDateObj.S);
		
		//MONTH
		ret=ret.replace(/%F/g,byDateObj.F);
		ret=ret.replace(/%M/g,byDateObj.M);
		ret=ret.replace(/%m/g,byDateObj.m);
		ret=ret.replace(/%n/g,byDateObj.n);
		
		//YEAR
		ret=ret.replace(/%Y/g,byDateObj.Y);
		ret=ret.replace(/%y/g,byDateObj.y);
		
		//TIME
		ret=ret.replace(/%a/g,byDateObj.a);
		ret=ret.replace(/%A/g,byDateObj.A);
		ret=ret.replace(/%g/g,byDateObj.g);
		ret=ret.replace(/%h/g,byDateObj.h);
		ret=ret.replace(/%G/g,byDateObj.G);
		ret=ret.replace(/%H/g,byDateObj.H);
		ret=ret.replace(/%i/g,byDateObj.i);
		ret=ret.replace(/%s/g,byDateObj.s);
		
		return ret;
	},
	GetDateObj:function(byDate,byTimeZone){
		if (byDate==""){
			if (byTimeZone==-1){
				byDate = new Date();
			}else{
				byDate = new Date(System.Time.getLocalTime(System.Time.timeZones.item(parseInt(byTimeZone))));
			}
		}
		if (byDate.getMilliseconds()>500){
			byDate.setSeconds(byDate.getSeconds()+1);
		}
		var hr24 = byDate.getHours();
		var mn = byDate.getMinutes();
		var sc = byDate.getSeconds();
		var ampm = "am"
		var hr12 = hr24;
		if (sc < 10){
			sc = "0"+sc;
		}
		if (mn < 10){
			mn = "0"+mn;
		}
		if (hr12 > 11){
			hr12 -= 12;
			ampm = "pm";
		}
		if (hr12 == 0){hr12 = 12}
		
		var suffix=byDate.getDate().toString();
		suffix=suffix.substr(suffix.length-1);
		suffix=this.Suffixes[suffix];
		var lzDay=byDate.getDate();
		if (lzDay<10){lzDay="0"+lzDay}
		var lzMonth=byDate.getMonth()+1;
		if (lzMonth<10){lzMonth="0"+lzMonth}
		var lzHr12=hr12;
		if (lzHr12<10){lzHr12="0"+lzHr12}
		var lzHr24=hr24;
		if (lzHr24<10){lzHr24="0"+lzHr24}
		return {d:lzDay,
				j:byDate.getDate().toString(),
				D:this.Days[byDate.getDay()].substr(0,3),
				l:this.Days[byDate.getDay()],
				S:suffix,
				F:this.Months[byDate.getMonth()],
				M:this.Months[byDate.getMonth()].substr(0,3),
				m:lzMonth.toString(),
				n:(byDate.getMonth()+1).toString(),
				Y:byDate.getFullYear().toString(),
				y:byDate.getFullYear().toString().substr(2,2),
				a:ampm,
				A:ampm.toUpperCase(),
				g:hr12.toString(),
				h:lzHr12.toString(),
				G:hr24.toString(),
				H:lzHr24.toString(),
				i:mn.toString(),
				s:sc.toString(),
				date:byDate
				};
	},
	TilNextSecond:function(byDate){
		return 1000 - new Date().getMilliseconds();
	},
	Months:[],
	AbbMonths:[],
	Days:[],
	AbbDays:[],
	Suffixes:["th","st","nd","rd","th","th","th","th","th","th"]
};
DateTime.SetLanguage(-1);